---
policy: /ce/ca/azure/app-service/app-service-registered-with-microsoft-entra-id
logic: /ce/ca/azure/app-service/app-service-registered-with-microsoft-entra-id/prod.logic.yaml
executionTime: 2025-04-24T23:45:15.137183222Z
rows:
  - id: test1
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10__disappearanceTime__c)
      actual: isDisappeared(CA10__disappearanceTime__c)
    runtimeError: {}
  - id: test2
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 199
      actual: 199
    conditionText:
      expected: extract('CA10__identityPrincipalId__c').isEmpty()
      actual: extract('CA10__identityPrincipalId__c').isEmpty()
    runtimeError: {}
  - id: test3
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 200
      actual: 200
    conditionText:
      expected: otherwise
      actual: otherwise
    runtimeError: {}
usedFiles:
  - path: /ce/ca/azure/app-service/app-service-registered-with-microsoft-entra-id/policy.yaml
    md5Hash: 4DE95CFAE996E810288F66012FBE33CB
    content: |
      ---
      names:
        full: Azure App Service is not registered with Microsoft Entra ID
        contextual: App Service is not registered with Microsoft Entra ID
      description: "Managed service identity in App Service provides more security by eliminating\
        \ secrets from the app, such as credentials in the connection strings. When registering\
        \ an App Service with Entra ID, the app will connect to other Azure services securely\
        \ without the need for usernames and passwords."
      type: COMPLIANCE_POLICY
      categories:
        - SECURITY
      frameworkMappings:
        - "/frameworks/cis-azure-v2.1.0/09/04"
        - "/frameworks/cis-azure-v3.0.0/09/05"
        - "/frameworks/cloudaware/resource-security/secure-access"
      similarPolicies:
        internal:
          - dec-x-1fc681bc
        cloudConformity:
          - url: https://www.trendmicro.com/cloudoneconformity/knowledge-base/azure/AppService/enable-registration-with-microsoft-entra-id.html
            name: Enable Registration with Microsoft Entra ID
  - path: /ce/ca/azure/app-service/app-service-registered-with-microsoft-entra-id/prod.logic.yaml
    md5Hash: 2D92FBD322EE3585D80093CA8CC5D8C9
    content: |
      ---
      inputType: "CA10__CaAzureAppService__c"
      importExtracts:
        - file: "/types/CA10__CaAzureAppService__c/object.extracts.yaml"
      testData:
        - file: "test-data.json"
      conditions:
        - status: "INCOMPLIANT"
          currentStateMessage: "App Service is not registered with Entra ID."
          remediationMessage: "Consider registering App Service with Entra ID."
          check:
            IS_EMPTY:
              arg:
                EXTRACT: "CA10__identityPrincipalId__c"
      otherwise:
        status: "COMPLIANT"
        currentStateMessage: "App Service is registered with Entra ID."
  - path: /ce/ca/azure/app-service/app-service-registered-with-microsoft-entra-id/test-data.json
    md5Hash: 64D549819F537B81A4E9137FF620D231
    content: |-
      [
          {
              "expectedResult": {
                  "status": "DISAPPEARED",
                  "conditionIndex": "99",
                  "conditionText": "isDisappeared(CA10__disappearanceTime__c)",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-28T08:24:16Z"
              },
              "Id": "test1",
              "CA10__disappearanceTime__c": "2024-06-20T20:56:36Z",
              "CA10__identityPrincipalId__c": ""
          },
          {
              "expectedResult": {
                  "status": "INCOMPLIANT",
                  "conditionIndex": "199",
                  "conditionText": "extract('CA10__identityPrincipalId__c').isEmpty()",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-28T08:24:16Z"
              },
              "Id": "test2",
              "CA10__disappearanceTime__c": null,
              "CA10__identityPrincipalId__c": ""
          },
          {
              "expectedResult": {
                  "status": "COMPLIANT",
                  "conditionIndex": "200",
                  "conditionText": "otherwise",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-28T08:24:16Z"
              },
              "Id": "test3",
              "CA10__disappearanceTime__c": null,
              "CA10__identityPrincipalId__c": "aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee"
          }
      ]
  - path: /types/CA10__CaAzureAppService__c/object.extracts.yaml
    md5Hash: BA4130C0EACD0EA4C609D6BD75139054
    content: "---\nextracts:\n# Values: Enabled, Disabled. Not Nullable.\n  - name:\
      \ \"CA10__authStatus__c\"\n    value: \n      FIELD:\n        path: \"CA10__authStatus__c\"\
      \n        undeterminedIf:\n          noAccessDelegate:\n            path: \"\
      CA10__authStatus__c\"\n            currentStateMessage: \"Unable to determine\
      \ Auth Settings. Possible permission issue with Microsoft.Web/sites/config/authsettings/list\"\
      \n# Values: Enabled, Disabled. Not Nullable.\n  - name: \"CA10__basicPublishingCredentialsFtpState__c\"\
      \n    value: \n      FIELD:\n        path: \"CA10__basicPublishingCredentialsFtpState__c\"\
      \n        undeterminedIf:\n          noAccessDelegate:\n            path: \"\
      CA10__basicPublishingCredentialsFtpState__c\"\n            currentStateMessage:\
      \ \"Unable to determine Basic Auth Settings. Possible permission issue with\
      \ Microsoft.Web/sites/basicPublishingCredentialsPolicies\"\n# Values: Enabled,\
      \ Disabled. Not Nullable.\n  - name: \"CA10__basicPublishingCredentialsScmState__c\"\
      \n    value: \n      FIELD:\n        path: \"CA10__basicPublishingCredentialsScmState__c\"\
      \n        undeterminedIf:\n          noAccessDelegate:\n            path: \"\
      CA10__basicPublishingCredentialsScmState__c\"\n            currentStateMessage:\
      \ \"Unable to determine Basic Auth Settings. Possible permission issue with\
      \ Microsoft.Web/sites/basicPublishingCredentialsPolicies\"\n# Values: Enabled,\
      \ Disabled. Not Nullable. Can't have no access, retrieved via Microsoft.Web/sites\n\
      \  - name: \"CA10__httpsOnly__c\"\n    value: \n      FIELD:\n        path:\
      \ \"CA10__httpsOnly__c\"\n        undeterminedIf:\n          isEmpty: \"Corrupted\
      \ data. HTTPS Only configuration cannot be empty.\"\n# Values: 1.0, 1.1, 1.2.\
      \ Not Nullable.\n  - name: \"CA10__configMinTlsVersion__c\"\n    value: \n \
      \     FIELD:\n        path: \"CA10__configMinTlsVersion__c\"\n        undeterminedIf:\n\
      \          noAccessDelegate:\n            path: \"CA10__configMinTlsVersion__c\"\
      \n            currentStateMessage: \"Unable to determine minimum version of\
      \ TLS. Possible permission issue with Microsoft.Web/sites/config/web/read\"\n\
      # Nullable. Can't have no access, retrieved via Microsoft.Web/sites\n  - name:\
      \ \"CA10__identityPrincipalId__c\"\n    value: \n      FIELD:\n        path:\
      \ \"CA10__identityPrincipalId__c\"\n# Values: Enabled, Disabled. Not Nullable.\n\
      \  - name: \"CA10__configHttp20__c\"\n    value: \n      FIELD:\n        path:\
      \ \"CA10__configHttp20__c\"\n        undeterminedIf:\n          noAccessDelegate:\n\
      \            path: \"CA10__configHttp20__c\"\n            currentStateMessage:\
      \ \"Unable to determine HTTP2.0 configuration. Possible permission issue with\
      \ Microsoft.Web/sites/config/web/read\"\n# Values: AllAllowed, Disabled, FtpsOnly.\
      \ Not Nullable.\n  - name: \"CA10__configFtpsState__c\"\n    value: \n     \
      \ FIELD:\n        path: \"CA10__configFtpsState__c\"\n        undeterminedIf:\n\
      \          noAccessDelegate:\n            path: \"CA10__configFtpsState__c\"\
      \n            currentStateMessage: \"Unable to determine FTPS State. Possible\
      \ permission issue with Microsoft.Web/sites/config/web/read\"\n# Values: Enabled,\
      \ Disabled. Not Nullable.\n  - name: \"CA10__configRemoteDebugging__c\"\n  \
      \  value: \n      FIELD:\n        path: \"CA10__configRemoteDebugging__c\"\n\
      \        undeterminedIf:\n          noAccessDelegate:\n            path: \"\
      CA10__configRemoteDebugging__c\"\n            currentStateMessage: \"Unable\
      \ to determine FTPS State. Possible permission issue with Microsoft.Web/sites/config/web/read\"\
      \n"
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "test1",
    "expectedResult" : {
      "status" : "DISAPPEARED",
      "conditionIndex" : "99",
      "conditionText" : "isDisappeared(CA10__disappearanceTime__c)",
      "runtimeError" : null
    }
  }, {
    "Id" : "test2",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "199",
      "conditionText" : "extract('CA10__identityPrincipalId__c').isEmpty()",
      "runtimeError" : null
    }
  }, {
    "Id" : "test3",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "200",
      "conditionText" : "otherwise",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaAzureAppService__c()
  RETURNS ARRAY<STRUCT<
      Id STRING,
      CA10__disappearanceTime__c TIMESTAMP,
      CA10__identityPrincipalId__c STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2024-06-28T08:24:16Z")
    },
    "Id" : "test1",
    "CA10__disappearanceTime__c" : new Date("2024-06-20T20:56:36Z"),
    "CA10__identityPrincipalId__c" : ""
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-06-28T08:24:16Z")
    },
    "Id" : "test2",
    "CA10__identityPrincipalId__c" : ""
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-06-28T08:24:16Z")
    },
    "Id" : "test3",
    "CA10__identityPrincipalId__c" : "aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaAzureAppService__c(
      obj STRUCT<
          Id STRING,
          CA10__disappearanceTime__c TIMESTAMP,
          CA10__identityPrincipalId__c STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
      var TextLib = new function () {
          this.normalize = function(arg) {
              return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
          };
          this.isEmpty = function(arg) {
              return this.normalize(arg) == '';
          };
          this.isNotEmpty = function(arg) {
              return this.normalize(arg) != '';
          };
          this.equal = function(left, right) {
              return this.normalize(left) == this.normalize(right);
          };
          this.notEqual = function(left, right) {
              return this.normalize(left) != this.normalize(right);
          };
          this.startsWith = function(arg, substring) {
              return this.normalize(arg).startsWith(this.normalize(substring));
          };
          this.endsWith = function(arg, substring) {
              return this.normalize(arg).endsWith(this.normalize(substring));
          };
          this.contains = function(arg, substring) {
              return this.normalize(arg).includes(this.normalize(substring));
          };
      }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From Azure [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function extract3() { if (!this.out) { this.out = obj.CA10__identityPrincipalId__c; } return this.out; };
      references1.push('Identity: Principal ID [obj.CA10__identityPrincipalId__c]: ' + obj.CA10__identityPrincipalId__c);
      if (TextLib.isEmpty(extract3.call(extract3))) {
          return {status: 'INCOMPLIANT', conditionIndex: 199, conditionText: "extract('CA10__identityPrincipalId__c').isEmpty()", currentStateMessage: "App Service is not registered with Entra ID.", currentStateReferences: references1.join('\n'), remediation: "Consider registering App Service with Entra ID.", runtimeError: null};
      }
      return {status: 'COMPLIANT', conditionIndex: 200, conditionText: "otherwise", currentStateMessage: "App Service is registered with Entra ID.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.Id AS Id,
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          sObject.CA10__identityPrincipalId__c AS CA10__identityPrincipalId__c,
          process_CA10__CaAzureAppService__c(
              STRUCT(
                  sObject.Id AS Id,
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
                  sObject.CA10__identityPrincipalId__c AS CA10__identityPrincipalId__c
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaAzureAppService__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
